#!/common/math/9.0/Executables/MathKernel -script
(* The above line has to be at the start of the script  *)

(* Get command line input on number of kernels to use *)
nkernel= ToExpression[$CommandLine[[4;;]]]
LaunchKernels[nkernel]
Print[nkernel]

AppendTo[$Echo, "stdout"]

$MachineName
$NumberMarks=False

(* Code to estimate Pi using Monte Carlo Simulation in parallel *)
(*  Work is partitioned among available kernels  *)
Print /@ AbsoluteTiming[With[ {NUMPOINTS = 300000000, CPUS = Length[Kernels[]]},
  partitions = (Quotient[NUMPOINTS, CPUS] + 
     Join[Table[1, {Mod[NUMPOINTS, CPUS]}], 
      Table[0, {CPUS - Mod[NUMPOINTS, CPUS]}]]);
  N[Total@
      ParallelMap[# + 
         Total[Round[-Total[
              RandomReal[{-1/2, 1/2}, {#, 2}]^2, {2}] - .25]] &, 
       partitions]/NUMPOINTS*(1/(1/2)^2)]]]
       
      Print[ N[Pi,20] ]
      
 (*  Close kernels after computation *)      
CloseKernels[]
